
#include <device.h>
#include <stdio.h>

#define FIFO_not_empty 	0x40
#define FIFO_ful		0x20
#define Capture_status	0x10


uint32 Cap1 = 0;
uint32 Cap2 = 0;
uint32 Cap3 = 0;
uint32 Cap4 = 0;
uint32 Count =0;

char buffer[40];
char CSReg;
char CSReg2;
char CSReg3;
void main()
{	

	PWM_Window_Start();
	Counter_Start();
	LCD_Start();
	Clock_PWM_Start();
	Clock_1_Start();
	CYGlobalIntEnable;			
	
	for(;;)
    {													// Active Flags		
		if (Counter_ReadStatusRegister() & FIFO_ful) 	// CSReg = 0x70 FIFO not empty, FIFO full, Capture status
			// CSReg = 0x60 FIFO not empty, FIFO full, Capture status ->0
		{					
//			Count = Counter_ReadCounter();				// Reading Counter here will destroy Capture Queue
			CSReg = Counter_ReadStatusRegister();
			
			Cap1 = Counter_ReadCapture();	
			// CSReg = 0x40 FIFO not empty, FIFO full ->0
			Cap2 = Counter_ReadCapture();			
			// CSReg = 0x40 FIFO not empty
			Cap3 = Counter_ReadCapture();			
			// CSReg = 0x40 FIFO not empty
			Cap4 = Counter_ReadCapture();			
			// CSReg = 0x00 FIFO not empty ->0

			CSReg = Counter_ReadStatusRegister();
			
//			Count = Counter_ReadCounter(); 				// Count = Cap4
			
			LCD_Position(0, 0);
			sprintf(buffer, "%9u %9u %9u %9u", Cap1, Cap2, Cap3, Cap4); 		
			LCD_PrintString(buffer);
			LCD_PrintString("C2-1 C3-2 C4-3");
			
			LCD_Position(1, 0);
			sprintf(buffer, "%X %4d %4d %4d ", CSReg, Cap2-Cap1, Cap3-Cap2, Cap4-Cap3);
			LCD_PrintString(buffer); 
		}
		
    }
}

/* [] END OF FILE */
