/*******************************************************************************
* File Name: LCD_Display_LCDPort.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_LCD_Display_LCDPort_ALIASES_H) /* Pins LCD_Display_LCDPort_ALIASES_H */
#define CY_PINS_LCD_Display_LCDPort_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"

/***************************************
*              Constants        
***************************************/
#define LCD_Display_LCDPort_0		LCD_Display_LCDPort__0__PC
#define LCD_Display_LCDPort_1		LCD_Display_LCDPort__1__PC
#define LCD_Display_LCDPort_2		LCD_Display_LCDPort__2__PC
#define LCD_Display_LCDPort_3		LCD_Display_LCDPort__3__PC
#define LCD_Display_LCDPort_4		LCD_Display_LCDPort__4__PC
#define LCD_Display_LCDPort_5		LCD_Display_LCDPort__5__PC
#define LCD_Display_LCDPort_6		LCD_Display_LCDPort__6__PC

#define LCD_Display_LCDPort_D0		LCD_Display_LCDPort__D0__PC
#define LCD_Display_LCDPort_D1		LCD_Display_LCDPort__D1__PC
#define LCD_Display_LCDPort_D2		LCD_Display_LCDPort__D2__PC
#define LCD_Display_LCDPort_D3		LCD_Display_LCDPort__D3__PC
#define LCD_Display_LCDPort_E_4		LCD_Display_LCDPort__E_4__PC
#define LCD_Display_LCDPort_RS_5		LCD_Display_LCDPort__RS_5__PC
#define LCD_Display_LCDPort_RW_6		LCD_Display_LCDPort__RW_6__PC

#endif /* End Pins LCD_Display_LCDPort_ALIASES_H */

/* [] END OF FILE */
